; 2013  ; sprin

; :
;  *  4-  MC P1 (MCp0411100101)

; -: 
; typedef unsigned int   UINT32, *PUINT32;
; typedef unsigned __int64   UINT64, *PUINT64;
; UINT32 mc_POPCNT64_v3(UINT64 X);

.alias	SP	39	;   

.data

 .align	8

 popCountOfByte256:
    .byte \
           0, 1, 1, 2, 1, 2, 2, 3, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           5, 6, 6, 7, 6, 7, 7, 8

.text

.global mc_POPCNT64_v3
mc_POPCNT64_v3:
	.alias	mc_PopCnt64.RES    #SP, 4
	.alias	mc_PopCnt64.ARG1   #SP, 8

.local mc_PopCnt64.P0	;  13 
mc_PopCnt64.P0:
                ;  
 NextP :=       rdl	#SP
                jmp	@NextP

                ;   
 a1 :=          rdq	mc_PopCnt64.ARG1

 l1 :=          slrl	@a1, 8
 l2 :=          slrl	@a1, 16
 l3 :=          slrl	@a1, 24
 l4 :=          slrq	@a1, 32
 l5 :=          slrq	@a1, 40
 l6 :=          slrq	@a1, 48
 l7 :=          slrq	@a1, 56

 l8 :=          and	@a1, 0xFF

 l9 :=          and	@l1, 0xFF
 l10 :=         and	@l2, 0xFF
 l11 :=         and	@l3, 0xFF
 l12 :=         and	@l4, 0xFF
 l13 :=         and	@l5, 0xFF
 l14 :=         and	@l6, 0xFF

 l15 :=         addl	@l8, popCountOfByte256
 l16 :=         addl	@l9, popCountOfByte256
 l17 :=         addl	@l10, popCountOfByte256
 l18 :=         addl	@l11, popCountOfByte256
 l19 :=         addl	@l12, popCountOfByte256
 l20 :=         addl	@l13, popCountOfByte256
 l21 :=         addl	@l14, popCountOfByte256
 l22 :=         addl	@l7, popCountOfByte256

 l23 :=         rdb	@l15
 l24 :=         rdb	@l16
 l25 :=         rdb	@l17
 l26 :=         rdb	@l18
 l27 :=         rdb	@l19
 l28 :=         rdb	@l20
 l29 :=         rdb	@l21
 l30 :=         rdb	@l22

 l31 :=         addl	@l23, @l24
 l32 :=         addl	@l25, @l26
 l33 :=         addl	@l27, @l28
 l34 :=         addl	@l29, @l30
 l35 :=         addl	@l31, @l32
 l36 :=         addl	@l33, @l34
 l37 :=         addl	@l35, @l36

                ;     
                wrl	@l37, mc_PopCnt64.RES
complete

.end


;====================================================================

;  13 
T\C	1	2	3	4
1	1	2.	3	4.
2	5	2	6	4
3	7	8	9	10
4	11	12	13	14
5	15	16	17	18
6	19	20	21	22
7	23	24	25	26
8	27	28	29	30
9	31	32	33	34
10	35	36	37	38.
11	39	40.	41.	38
12	-	40	41.	-
13	-	-	41	-

;====================================================================
