; 2013  ; sprin

; :
;  *  4-  MC P1 (MCp0411100101)

; -: 
; typedef unsigned int   UINT32, *PUINT32;
; typedef unsigned __int64   UINT64, *PUINT64;
; UINT32 mc_POPCNT64_v3b(UINT64 X);

;  :
;  * mc_POPCNT64_v3b   mc_POPCNT64_v3 , 
;     mc_POPCNT64_v3b     2  ( 4 )

.alias	SP	39	;   

.data

 .align	8

 popCountOfByte256:
    .byte \
           0, 1, 1, 2, 1, 2, 2, 3, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           5, 6, 6, 7, 6, 7, 7, 8

.text

.global mc_POPCNT64_v3b
mc_POPCNT64_v3b:
	.alias	mc_PopCnt64.RES    #SP, 4
	.alias	mc_PopCnt64.ARG1l  #SP, 8
	.alias	mc_PopCnt64.ARG1h  #SP, 12

.local mc_PopCnt64.P0	;  12 
mc_PopCnt64.P0:
                ;  .  1  2
 NextP :=       rdl	#SP

                ;   
 a1l :=         rdl	mc_PopCnt64.ARG1l
 a1h :=         rdl	mc_PopCnt64.ARG1h

 rl1 :=         slrl	@a1l, 8
 rl2 :=         slrl	@a1l, 16
 rl3 :=         slrl	@a1l, 24
 rh1 :=         slrl	@a1h, 8
 rh2 :=         slrl	@a1h, 16
 rh3 :=         slrl	@a1h, 24

 rl4 :=         and	@a1l, 0xFF
 rh4 :=         and	@a1h, 0xFF

 rl5 :=         and	@rl1, 0xFF
 rl6 :=         and	@rl2, 0xFF
 rh5 :=         and	@rh1, 0xFF
 rh6 :=         and	@rh2, 0xFF

 rl8 :=         addl	@rl3, popCountOfByte256
 rl9 :=         addl	@rl4, popCountOfByte256
 rl10 :=        addl	@rl5, popCountOfByte256
 rl11 :=        addl	@rl6, popCountOfByte256
 rh8 :=         addl	@rh3, popCountOfByte256
 rh9 :=         addl	@rh4, popCountOfByte256
 rh10 :=        addl	@rh5, popCountOfByte256
 rh11 :=        addl	@rh6, popCountOfByte256

 rl12 :=        rdb	@rl8
 rl13 :=        rdb	@rl9
 rl14 :=        rdb	@rl10
 rl15 :=        rdb	@rl11
 rh12 :=        rdb	@rh8
 rh13 :=        rdb	@rh9
 rh14 :=        rdb	@rh10
 rh15 :=        rdb	@rh11

 rl16 :=        addl	@rl12, @rl13
 rl17 :=        addl	@rl14, @rl15
 rh16 :=        addl	@rh12, @rh13
 rh17 :=        addl	@rh14, @rh15
 rl18 :=        addl	@rl16, @rl17
 rh18 :=        addl	@rh16, @rh17

 r19 :=         addl	@rl18, @rh18

                wrl	@r19, mc_PopCnt64.RES ;     

                ;  .  2  2
                jmp	@NextP
complete

.end


;====================================================================

;  12 
T\C	1	2	3	4
1	1	2	3	4.
2	5	6	7	4
3	8	9	10	11
4	12	13	14	15
5	16	17	18	19
6	20	21	22	23
7	24	25	26	27
8	28	29	30	31
9	32	33	34	35
10	36	37	38.	39.
11	40	-	38	39.
12	-	-	-	39

;====================================================================
