; 2013  ; sprin

; :
;  *  4-  MC P1 (MCp0411100101)

; -: 
; typedef unsigned int   UINT32, *PUINT32;
; typedef unsigned __int64   UINT64, *PUINT64;
; UINT32 mc_POPCNT64_v4(UINT64 X);

;  :
;  * ..    POPCNT     ,
;         ( ,    
;        ),      2 .


.alias	SP	39	;   

.text

.global mc_POPCNT64_v4
mc_POPCNT64_v4:
	.alias	mc_POPCNT64.m1  011111111111	; //binary: 01001001001001001001001001001001
	.alias	mc_POPCNT64.m2  033333333333	; //binary: 11011011011011011011011011011011
	.alias	mc_POPCNT64.m3  030707070707	; //binary: 11000111000111000111000111000111

	.alias	mc_POPCNT64.RES     #SP, 4
	.alias	mc_POPCNT64.ARG1l   #SP, 8
	.alias	mc_POPCNT64.ARG1h   #SP, 12

.local mc_POPCNT64.P0	;  19 
mc_POPCNT64.P0:
                ;   
 a1l :=         rdl	mc_POPCNT64.ARG1l
 a1h :=         rdl	mc_POPCNT64.ARG1h

 a1ll :=        and	@a1l, 0xFFFF
 a1hl :=        and	@a1h, 0xFFFF
 a1lh :=        slrl	@a1l, 0x10
 a1hh :=        slrl	@a1h, 0x10

 rll1 :=        slrl	@a1ll, 0x1
 rll2 :=        slrl	@a1ll, 0x2
 rhl1 :=        slrl	@a1hl, 0x1
 rhl2 :=        slrl	@a1hl, 0x2

 rlh1 :=        slrl	@a1lh, 0x1
 rlh2 :=        slrl	@a1lh, 0x2
 rhh1 :=        slrl	@a1hh, 0x1
 rhh2 :=        slrl	@a1hh, 0x2

 rll3 :=        and	@rll1, mc_POPCNT64.m2
 rll4 :=        and	@rll2, mc_POPCNT64.m1
 rhl3 :=        and	@rhl1, mc_POPCNT64.m2
 rhl4 :=        and	@rhl2, mc_POPCNT64.m1

 rlh3 :=        and	@rlh1, mc_POPCNT64.m2
 rlh4 :=        and	@rlh2, mc_POPCNT64.m1
 rhh3 :=        and	@rhh1, mc_POPCNT64.m2
 rhh4 :=        and	@rhh2, mc_POPCNT64.m1

 rll5 :=        subl	@a1ll, @rll3
 rhl5 :=        subl	@a1hl, @rhl3
 rlh5 :=        subl	@a1lh, @rlh3
 rhh5 :=        subl	@a1hh, @rhh3

 rll6 :=        subl	@rll5, @rll4
 rhl6 :=        subl	@rhl5, @rhl4
 rlh6 :=        subl	@rlh5, @rlh4
 rhh6 :=        subl	@rhh5, @rhh4

 rll7 :=        slrl	@rll6, 0x3
 rhl7 :=        slrl	@rhl6, 0x3
 rlh7 :=        slrl	@rlh6, 0x3
 rhh7 :=        slrl	@rhh6, 0x3

 rll8 :=        addl	@rll6, @rll7
 rhl8 :=        addl	@rhl6, @rhl7
 rlh8 :=        addl	@rlh6, @rlh7
 rhh8 :=        addl	@rhh6, @rhh7

 rll9 :=        and	@rll8, mc_POPCNT64.m3
 rhl9 :=        and	@rhl8, mc_POPCNT64.m3
 rlh9 :=        and	@rlh8, mc_POPCNT64.m3
 rhh9 :=        and	@rhh8, mc_POPCNT64.m3

                ; x % 63
 rll10 :=       clf	@rll9
 rhl10 :=       clf	@rhl9
 rlh10 :=       clf	@rlh9
 rhh10 :=       clf	@rhh9

 rll11 :=       divf	@rll10, 0f63.0
 rhl11 :=       divf	@rhl10, 0f63.0
 rlh11 :=       divf	@rlh10, 0f63.0
 rhh11 :=       divf	@rhh10, 0f63.0

 rll12 :=       cfsl	@rll11
 rhl12 :=       cfsl	@rhl11
 rlh12 :=       cfsl	@rlh11
 rhh12 :=       cfsl	@rhh11

 rll13 :=       mull	@rll12, 63
 rhl13 :=       mull	@rhl12, 63
 rlh13 :=       mull	@rlh12, 63
 rhh13 :=       mull	@rhh12, 63

 rll14 :=       subl	@rll9, @rll13
 rhl14 :=       subl	@rhl9, @rhl13
 rlh14 :=       subl	@rlh9, @rlh13
 rhh14 :=       subl	@rhh9, @rhh13

 rll19 :=       abssl	@rll14
 rhl19 :=       abssl	@rhl14
 rlh19 :=       abssl	@rlh14
 rhh19 :=       abssl	@rhh14

 l20 :=         addl	@rll19, @rhl19
 l21 :=         addl	@rlh19, @rhh19
 l22 :=         addl	@l20, @l21

                ;  
 NextP :=       rdl	#SP
                jmp	@NextP

                ;     
                wrl	@l22, mc_POPCNT64.RES
complete

.end


;====================================================================

;  19 
T\C	1	2	3	4
1	1	2	3.	4.
2	5	6	3	4
3	7	8	9	10
4	11	12	13	14
5	15	16	17	18
6	19	20	21	22
7	23	24	25	26
8	27	28	29	30
9	31	32	33	34
10	35	36	37	38
11	39	40	41	42
12	43	44	45	46
13	47	48	49	50
14	51	52	53	54
15	55	56	57	58
16	59	60	61	62
17	63	64	65.	66
18	67	68.	65	-
19	-	68	-	-

;====================================================================
