; 2013  ; sprin

; :
;  *  4-  MC P1 (MCp0411100101)

; -: 
; typedef unsigned int   UINT32, *PUINT32;
; typedef unsigned __int64   UINT64, *PUINT64;
; UINT32 mc_POPCNT64_v1(UINT64 X);

;  :
;  *     4 , ..    :
;     subq, addq, mulq


.alias	SP	39	;   

.text

.global mc_POPCNT64_v1
mc_POPCNT64_v1:
	.alias	mc_PopCnt64.m1  0x55555555	; //binary: 0101...
	.alias	mc_PopCnt64.m2  0x33333333	; //binary: 00110011..
	.alias	mc_PopCnt64.m4  0x0f0f0f0f	; //binary:  4 zeros,  4 ones ...
	.alias	mc_PopCnt64.h01 0x01010101	; //the sum of 256 to the power of 0,1,2,3...

	.alias	mc_PopCnt64.RES   #SP, 4
	.alias	mc_PopCnt64.ARG1l #SP, 8
	.alias	mc_PopCnt64.ARG1h #SP, 12

.local mc_PopCnt64.P0	;  14 
mc_PopCnt64.P0:
                ;  
 NextP :=       rdl	#SP
                jmp	@NextP

                ;   
 a1l :=         rdl	mc_PopCnt64.ARG1l
 a1h :=         rdl	mc_PopCnt64.ARG1h

 rl1_1 :=       slrl	@a1l, 0x1
 rh1_1 :=       slrl	@a1h, 0x1
 rl1_2 :=       and	@rl1_1, mc_PopCnt64.m1
 rh1_2 :=       and	@rh1_1, mc_PopCnt64.m1
 rl1 :=         subl	@a1l, @rl1_2
 rh1 :=         subl	@a1h, @rh1_2

 rl2_1 :=       and	@rl1, mc_PopCnt64.m2
 rh2_1 :=       and	@rh1, mc_PopCnt64.m2
 rl2_2 :=       slrl	@rl1, 0x2
 rh2_2 :=       slrl	@rh1, 0x2
 rl2_3 :=	and	@rl2_2, mc_PopCnt64.m2
 rh2_3 :=	and	@rh2_2, mc_PopCnt64.m2
 rl2 :=         addl	@rl2_3, @rl2_1
 rh2 :=         addl	@rh2_3, @rh2_1

 rl3_1 :=       slrl	@rl2, 0x4
 rh3_1 :=       slrl	@rh2, 0x4
 rl3_2 :=       addl	@rl2, @rl3_1
 rh3_2 :=       addl	@rh2, @rh3_1
 rl3 :=         and	@rl3_2, mc_PopCnt64.m4
 rh3 :=         and	@rh3_2, mc_PopCnt64.m4

 rl4_1 :=       mull	@rl3, mc_PopCnt64.h01	;      .
 rh4_1 :=       mull	@rh3, mc_PopCnt64.h01	;      .
 rl4 :=         slrl	@rl4_1, 0x18		; 0x18 = 24
 rh4 :=         slrl	@rh4_1, 0x18		; 0x18 = 24

 r4 :=          addl	@rl4, @rh4

                ;     
                wrl	@r4, mc_PopCnt64.RES
complete

.end


;====================================================================

;  14 
T\C	1	2	3	4
1	1	2.	3	4
2	5	2	6	7.
3	8	9.	10.	7
4	11.	9	10	12.
5	11	13	14	12
6	15	16	17.	18.
7	19.	20.	17	18
8	19	20	21.	22.
9	23.	24.	21	22
10	23	24	25.	26.
11	27.	28.	25	26
12	27	28	29.	30.
13	-	-	29	30.
14	-	-	-	30

;====================================================================
